<?php
/**
 * Life Coach Agency Theme Customizer.
 *
 * @link https://developer.wordpress.org/themes/basics/theme-functions/
 *
 * @package life_coach_agency
 */

if( ! function_exists( 'life_coach_agency_customize_register' ) ):  
/**
 * Add postMessage support for site title and description for the Theme Customizer.F
 *
 * @param WP_Customize_Manager $wp_customize Theme Customizer object.
 */
function life_coach_agency_customize_register( $wp_customize ) {
    require get_parent_theme_file_path('/inc/controls/changeable-icon.php');

    require get_parent_theme_file_path('/inc/controls/sortable-control.php');
    
    //Register the sortable control type.
    $wp_customize->register_control_type( 'Life_Coach_Agency_Control_Sortable' ); 

    if ( version_compare( get_bloginfo('version'),'4.9', '>=') ) {
        $wp_customize->get_section( 'static_front_page' )->title = __( 'Static Front Page', 'life-coach-agency' );
    }
	
    /* Option list of all post */	
    $life_coach_agency_options_posts = array();
    $life_coach_agency_options_posts_obj = get_posts('posts_per_page=-1');
    $life_coach_agency_options_posts[''] = esc_html__( 'Choose Post', 'life-coach-agency' );
    foreach ( $life_coach_agency_options_posts_obj as $life_coach_agency_posts ) {
    	$life_coach_agency_options_posts[$life_coach_agency_posts->ID] = $life_coach_agency_posts->post_title;
    }
    
    /* Option list of all categories */
    $life_coach_agency_args = array(
	   'type'                     => 'post',
	   'orderby'                  => 'name',
	   'order'                    => 'ASC',
	   'hide_empty'               => 1,
	   'hierarchical'             => 1,
	   'taxonomy'                 => 'category'
    ); 
    $life_coach_agency_option_categories = array();
    $life_coach_agency_category_lists = get_categories( $life_coach_agency_args );
    $life_coach_agency_option_categories[''] = esc_html__( 'Choose Category', 'life-coach-agency' );
    foreach( $life_coach_agency_category_lists as $life_coach_agency_category ){
        $life_coach_agency_option_categories[$life_coach_agency_category->term_id] = $life_coach_agency_category->name;
    }
    
    /** Default Settings */    
    $wp_customize->add_panel( 
        'wp_default_panel',
         array(
            'priority' => 10,
            'capability' => 'edit_theme_options',
            'theme_supports' => '',
            'title' => esc_html__( 'Default Settings', 'life-coach-agency' ),
            'description' => esc_html__( 'Default section provided by wordpress customizer.', 'life-coach-agency' ),
        ) 
    );
    
    $wp_customize->get_section( 'title_tagline' )->panel                  = 'wp_default_panel';
    $wp_customize->get_section( 'colors' )->panel                         = 'wp_default_panel';
    $wp_customize->get_section( 'header_image' )->panel                   = 'wp_default_panel';
    $wp_customize->get_section( 'background_image' )->panel               = 'wp_default_panel';
    $wp_customize->get_section( 'static_front_page' )->panel              = 'wp_default_panel';
    
    $wp_customize->get_setting( 'blogname' )->transport         = 'postMessage';
	$wp_customize->get_setting( 'blogdescription' )->transport  = 'postMessage';
	$wp_customize->get_setting( 'header_textcolor' )->transport = 'postMessage';
    
    /** Default Settings Ends */

    /** Site Title control */
    $wp_customize->add_setting( 
        'header_site_title', 
        array(
            'default'           => false,
            'sanitize_callback' => 'life_coach_agency_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'header_site_title',
        array(
            'label'       => __( 'Show / Hide Site Title', 'life-coach-agency' ),
            'section'     => 'title_tagline',
            'type'        => 'checkbox',
        )
    );

    /** Tagline control */
    $wp_customize->add_setting( 
        'header_tagline', 
        array(
            'default'           => false,
            'sanitize_callback' => 'life_coach_agency_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'header_tagline',
        array(
            'label'       => __( 'Show / Hide Tagline', 'life-coach-agency' ),
            'section'     => 'title_tagline',
            'type'        => 'checkbox',
        )
    );

    $wp_customize->add_setting('logo_width', array(
        'sanitize_callback' => 'absint', 
    ));

    // Add a control for logo width
    $wp_customize->add_control('logo_width', array(
        'label' => __('Logo Width', 'life-coach-agency'),
        'section' => 'title_tagline',
        'type' => 'number',
        'input_attrs' => array(
            'min' => '50', 
            'max' => '500', 
            'step' => '5', 
    ),
        'default' => '100', 
    ));
    $wp_customize->add_setting( 'life_coach_agency_site_title_size', array(
        'default'           => 30, // Default font size in pixels
        'sanitize_callback' => 'absint', // Sanitize the input as a positive integer
    ) );

    // Add control for site title size
    $wp_customize->add_control( 'life_coach_agency_site_title_size', array(
        'type'        => 'number',
        'section'     => 'title_tagline', // You can change this section to your preferred section
        'label'       => __( 'Site Title Font Size (px)', 'life-coach-agency' ),
        'input_attrs' => array(
            'min'  => 10,
            'max'  => 100,
            'step' => 1,
        ),
    ) );

    /** Responsive Media settings */
    
    $wp_customize->add_section(
        'life_coach_agency_responsive_media_section',
        array(
            'title' => esc_html__( 'Responsive Media Settings', 'life-coach-agency' ),
            'priority' => 20,
            'capability' => 'edit_theme_options',
            'panel' => 'life_coach_agency_general_settings',
        )
    );

    /** Scroll to top Responsive control */
    $wp_customize->add_setting( 
        'life_coach_agency_resp_scroll_top', 
        array(
            'default' => 1,
            'sanitize_callback' => 'life_coach_agency_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'life_coach_agency_resp_scroll_top',
        array(
            'label'       => __( 'Show Scroll To Top', 'life-coach-agency' ),
            'section'     => 'life_coach_agency_responsive_media_section',
            'type'        => 'checkbox',
        )
    );

        /** Scroll to top Responsive control */
    $wp_customize->add_setting( 
        'life_coach_agency_resp_loader', 
        array(
            'default' => 0,
            'sanitize_callback' => 'life_coach_agency_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'life_coach_agency_resp_loader',
        array(
            'label'       => __( 'Show Preloader', 'life-coach-agency' ),
            'section'     => 'life_coach_agency_responsive_media_section',
            'type'        => 'checkbox',
        )
    );

    /** Responsive Media Ends */

    //Global Color
    $wp_customize->add_section(
        'life_coach_agency_global_color',
        array(
            'title' => esc_html__( 'Global Color Settings', 'life-coach-agency' ),
            'priority' => 20,
            'capability' => 'edit_theme_options',
            'panel' => 'life_coach_agency_general_settings',
        )
    );

    $wp_customize->add_setting('life_coach_agency_primary_color', array(
        'default'           => '#f5aa36',
        'sanitize_callback' => 'sanitize_hex_color',
    ));
    $wp_customize->add_control(new WP_Customize_Color_Control($wp_customize, 'life_coach_agency_primary_color', array(
        'label'    => __('Theme Primary Color', 'life-coach-agency'),
        'section'  => 'life_coach_agency_global_color',
        'settings' => 'life_coach_agency_primary_color',
    )));    

    $wp_customize->add_setting('life_coach_agency_secondary_color', array(
        'default'           => '#ee691d',
        'sanitize_callback' => 'sanitize_hex_color',
    ));
    $wp_customize->add_control(new WP_Customize_Color_Control($wp_customize, 'life_coach_agency_secondary_color', array(
        'label'    => __('Theme Secondary Color', 'life-coach-agency'),
        'section'  => 'life_coach_agency_global_color',
        'settings' => 'life_coach_agency_secondary_color',
    ))); 

    /** Post & Pages */
    $wp_customize->add_panel( 
        'life_coach_agency_post_settings',
         array(
            'priority' => 40,
            'capability' => 'edit_theme_options',
            'title' => esc_html__( 'Post & Pages', 'life-coach-agency' ),
            'description' => esc_html__( 'Customize Post & Pages', 'life-coach-agency' ),
        ) 
    );

    /** Post Layouts */
    
    $wp_customize->add_section(
        'life_coach_agency_post_layout_section',
        array(
            'title' => esc_html__( 'Post Layout Settings', 'life-coach-agency' ),
            'priority' => 20,
            'capability' => 'edit_theme_options',
            'panel' => 'life_coach_agency_post_settings',
        )
    );

    $wp_customize->add_setting('life_coach_agency_post_layout_setting', array(
        'default'           => 'right-sidebar',
        'sanitize_callback' => 'life_coach_agency_sanitize_post_layout',
    ));

    $wp_customize->add_control('life_coach_agency_post_layout_setting', array(
        'label'    => __('Post Column Settings', 'life-coach-agency'),
        'section'  => 'life_coach_agency_post_layout_section',
        'settings' => 'life_coach_agency_post_layout_setting',
        'type'     => 'select',
        'choices'  => array(        
            'right-sidebar'   => __('Right Sidebar', 'life-coach-agency'),
            'left-sidebar'   => __('Left Sidebar', 'life-coach-agency'),
            'one-column'   => __('One Column', 'life-coach-agency'),
            'three-column'   => __('Three Columns', 'life-coach-agency'),
            'four-column'   => __('Four Columns', 'life-coach-agency'),
            'grid-layout'   => __('Grid Layout', 'life-coach-agency')
        ),
    ));

    $wp_customize->add_setting('life_coach_agency_archive_pagination_alignment',array(
        'default' => 'left-align',
        'sanitize_callback' => 'life_coach_agency_sanitize_pagination_alignment'
    ));
    $wp_customize->add_control('life_coach_agency_archive_pagination_alignment',array(
        'type' => 'select',
        'label' => __('Pagination Alignment','life-coach-agency'),
        'section' => 'life_coach_agency_post_layout_section',
        'choices' => array(
            'right-align' => __('Right Alignment','life-coach-agency'),
            'center-align' => __('Center Alignment','life-coach-agency'),
            'left-align' => __('Left Alignment','life-coach-agency'),
        ),
    ) );

     /** Post Layouts Ends */

    /** Post Settings */
    $wp_customize->add_section(
        'life_coach_agency_post_settings',
        array(
            'title' => esc_html__( 'Post Settings', 'life-coach-agency' ),
            'priority' => 20,
            'capability' => 'edit_theme_options',
            'panel' => 'life_coach_agency_post_settings',
        )
    );

    // Excerpt Length
    $wp_customize->add_section(
        'life_coach_agency_post_excerpt_length', 
        array(    
            'title'       => __('Excerpt Length', 'life-coach-agency'),
            'panel'       => 'theme_option_panel'    
        )
    );

    $wp_customize->add_setting( 
        'life_coach_agency_post_excerpt_length', 
        array(
            'default'           => '50',
            'sanitize_callback' => 'life_coach_agency_sanitize_number_range',
    ) );
    $wp_customize->add_control( 
        'life_coach_agency_post_excerpt_length', 
        array(
            'label'       => esc_html__( 'Excerpt Length', 'life-coach-agency' ),
            'section'     => 'life_coach_agency_post_settings',
            'type'        => 'number',
            'input_attrs' => array( 'min' => 1, 'max' => 200, 'style' => 'width: 100%;' ),
    ) );

    /** Post Heading control */
    $wp_customize->add_setting( 
        'life_coach_agency_post_heading_setting', 
        array(
            'default'           => true,
            'sanitize_callback' => 'life_coach_agency_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'life_coach_agency_post_heading_setting',
        array(
            'label'       => __( 'Show / Hide Post Heading', 'life-coach-agency' ),
            'section'     => 'life_coach_agency_post_settings',
            'type'        => 'checkbox',
        )
    );

    /** Post Meta control */
    $wp_customize->add_setting( 
        'life_coach_agency_post_meta_setting', 
        array(
            'default'           => true,
            'sanitize_callback' => 'life_coach_agency_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'life_coach_agency_post_meta_setting',
        array(
            'label'       => __( 'Show / Hide Post Meta', 'life-coach-agency' ),
            'section'     => 'life_coach_agency_post_settings',
            'type'        => 'checkbox',
        )
    );

    /** Post Image control */
    $wp_customize->add_setting( 
        'life_coach_agency_post_image_setting', 
        array(
            'default'           => true,
            'sanitize_callback' => 'life_coach_agency_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'life_coach_agency_post_image_setting',
        array(
            'label'       => __( 'Show / Hide Post Image', 'life-coach-agency' ),
            'section'     => 'life_coach_agency_post_settings',
            'type'        => 'checkbox',
        )
    );

    /** Post Content control */
    $wp_customize->add_setting( 
        'life_coach_agency_post_content_setting', 
        array(
            'default'           => true,
            'sanitize_callback' => 'life_coach_agency_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'life_coach_agency_post_content_setting',
        array(
            'label'       => __( 'Show / Hide Post Content', 'life-coach-agency' ),
            'section'     => 'life_coach_agency_post_settings',
            'type'        => 'checkbox',
        )
    );
    /** Post ReadMore control */
     $wp_customize->add_setting( 'life_coach_agency_post_content_setting', array(
        'default'           => true,
        'sanitize_callback' => 'life_coach_agency_sanitize_checkbox',
    ) );

    $wp_customize->add_control( 'life_coach_agency_post_content_setting', array(
        'type'        => 'checkbox',
        'section'     => 'life_coach_agency_post_settings', 
        'label'       => __( 'Display Content', 'life-coach-agency' ),
    ) );
    /** Post ReadMore control */
     $wp_customize->add_setting( 'life_coach_agency_read_more_button_setting', array(
        'default'           => true,
        'sanitize_callback' => 'life_coach_agency_sanitize_checkbox',
    ) );

    $wp_customize->add_control( 'life_coach_agency_read_more_button_setting', array(
        'type'        => 'checkbox',
        'section'     => 'life_coach_agency_post_settings', 
        'label'       => __( 'Display Read More Button', 'life-coach-agency' ),
    ) );

    $wp_customize->add_setting('life_coach_agency_single_post_align',array(
        'default' => 'left-align',
        'sanitize_callback' => 'life_coach_agency_sanitize_post_content_align'
    ));
    $wp_customize->add_control('life_coach_agency_single_post_align',array(
        'type' => 'select',
        'label' => __('Post Content Alignment','life-coach-agency'),
        'section' => 'life_coach_agency_post_settings',
        'choices' => array(
            'left-align' => __('Left Alignment','life-coach-agency'),
            'right-align' => __('Right Alignment','life-coach-agency'),
            'center-align' => __('Center Alignment','life-coach-agency'),
        ),
    ) );

    $wp_customize->add_setting('life_coach_agency_blog_meta_order', array(
        'default' => array('heading', 'author', 'featured-image', 'content','button'),
        'sanitize_callback' => 'life_coach_agency_sanitize_sortable',
    ));
    $wp_customize->add_control(new Life_Coach_Agency_Control_Sortable($wp_customize, 'life_coach_agency_blog_meta_order', array(
        'label' => esc_html__('Post Meta Ordering', 'life-coach-agency'),
        'description' => __('Drag & drop post items to rearrange the ordering ( this control will not function by post format )', 'life-coach-agency') ,
        'section' => 'life_coach_agency_post_settings',
        'choices' => array(
            'heading' => __('heading', 'life-coach-agency') ,
            'author' => __('author', 'life-coach-agency') ,
            'featured-image' => __('featured-image', 'life-coach-agency') ,
            'content' => __('content', 'life-coach-agency') ,
            'button' => __('button', 'life-coach-agency') ,
        ) ,
    )));
    
    /**  Post Settings Ends */

    /** Single Post Settings */
    $wp_customize->add_section(
        'life_coach_agency_single_post_settings',
        array(
            'title' => esc_html__( 'Single Post Settings', 'life-coach-agency' ),
            'priority' => 20,
            'capability' => 'edit_theme_options',
            'panel' => 'life_coach_agency_post_settings',
        )
    );

    /** Single Post Meta control */
    $wp_customize->add_setting( 
        'life_coach_agency_single_post_meta_setting', 
        array(
            'default'           => true,
            'sanitize_callback' => 'life_coach_agency_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'life_coach_agency_single_post_meta_setting',
        array(
            'label'       => __( 'Show / Hide Single Post Meta', 'life-coach-agency' ),
            'section'     => 'life_coach_agency_single_post_settings',
            'type'        => 'checkbox',
        )
    );

    /** Single Post Content control */
    $wp_customize->add_setting( 
        'life_coach_agency_single_post_content_setting', 
        array(
            'default'           => true,
            'sanitize_callback' => 'life_coach_agency_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'life_coach_agency_single_post_content_setting',
        array(
            'label'       => __( 'Show / Hide Single Post Content', 'life-coach-agency' ),
            'section'     => 'life_coach_agency_single_post_settings',
            'type'        => 'checkbox',
        )
    );

    /** Single Post Settings Ends */

    // Typography Settings Section
    $wp_customize->add_section('life_coach_agency_typography_settings', array(
        'title'      => esc_html__('Typography Settings', 'life-coach-agency'),
        'priority'   => 30,
        'capability' => 'edit_theme_options',
        'panel' => 'life_coach_agency_general_settings',
    ));

    // Array of fonts to choose from
    $font_choices = array(
        ''               => __('Select', 'life-coach-agency'),
        'Arial'          => 'Arial, sans-serif',
        'Verdana'        => 'Verdana, sans-serif',
        'Helvetica'      => 'Helvetica, sans-serif',
        'Times New Roman'=> '"Times New Roman", serif',
        'Georgia'        => 'Georgia, serif',
        'Courier New'    => '"Courier New", monospace',
        'Trebuchet MS'   => '"Trebuchet MS", sans-serif',
        'Tahoma'         => 'Tahoma, sans-serif',
        'Palatino'       => '"Palatino Linotype", serif',
        'Garamond'       => 'Garamond, serif',
        'Impact'         => 'Impact, sans-serif',
        'Comic Sans MS'  => '"Comic Sans MS", cursive, sans-serif',
        'Lucida Sans'    => '"Lucida Sans Unicode", sans-serif',
        'Arial Black'    => '"Arial Black", sans-serif',
        'Gill Sans'      => '"Gill Sans", sans-serif',
        'Segoe UI'       => '"Segoe UI", sans-serif',
        'Open Sans'      => '"Open Sans", sans-serif',
        'Roboto'         => 'Roboto, sans-serif',
        'Lato'           => 'Lato, sans-serif',
        'Montserrat'     => 'Montserrat, sans-serif',
        'Libre Baskerville' => 'Libre Baskerville',
    );

    // Heading Font Setting
    $wp_customize->add_setting('life_coach_agency_heading_font_family', array(
        'default'           => '',
        'sanitize_callback' => 'life_coach_agency_sanitize_choicess',
    ));
    $wp_customize->add_control('life_coach_agency_heading_font_family', array(
        'type'    => 'select',
        'choices' => $font_choices,
        'label'   => __('Select Font for Heading', 'life-coach-agency'),
        'section' => 'life_coach_agency_typography_settings',
    ));

    // Body Font Setting
    $wp_customize->add_setting('life_coach_agency_body_font_family', array(
        'default'           => '',
        'sanitize_callback' => 'life_coach_agency_sanitize_choicess',
    ));
    $wp_customize->add_control('life_coach_agency_body_font_family', array(
        'type'    => 'select',
        'choices' => $font_choices,
        'label'   => __('Select Font for Body', 'life-coach-agency'),
        'section' => 'life_coach_agency_typography_settings',
    ));

    /** Typography Settings Section End */

    /** General Settings */
    $wp_customize->add_panel( 
        'life_coach_agency_general_settings',
         array(
            'priority' => 40,
            'capability' => 'edit_theme_options',
            'title' => esc_html__( 'General Settings', 'life-coach-agency' ),
            'description' => esc_html__( 'Customize General Settings', 'life-coach-agency' ),
        ) 
    );

    /** General Settings */
    $wp_customize->add_section(
        'life_coach_agency_general_settings',
        array(
            'title' => esc_html__( 'Loader Settings', 'life-coach-agency' ),
            'priority' => 20,
            'capability' => 'edit_theme_options',
            'panel' => 'life_coach_agency_general_settings',
        )
    );

    /** Preloader control */
    $wp_customize->add_setting( 
        'life_coach_agency_preloader_setting', 
        array(
            'default'           => false,
            'sanitize_callback' => 'life_coach_agency_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'life_coach_agency_preloader_setting',
        array(
            'label'       => __( 'Show / Hide Preloader', 'life-coach-agency' ),
            'section'     => 'life_coach_agency_general_settings',
            'type'        => 'checkbox',
        )
    );

    /** General Settings Ends */

    /** Header Section Settings */
    $wp_customize->add_section(
        'life_coach_agency_header_section_settings',
        array(
            'title' => esc_html__( 'Header Section Settings', 'life-coach-agency' ),
            'priority' => 30,
            'capability' => 'edit_theme_options',
            'panel' => 'life_coach_agency_home_page_settings',
        )
    );

    /** Phone */
    $wp_customize->add_setting(
        'life_coach_agency_header_phone',
        array( 
            'default' => '',
            'sanitize_callback' => 'sanitize_text_field',
            'transport'         => 'refresh'
        )
    );
    
    $wp_customize->add_control(
        'life_coach_agency_header_phone',
        array(
            'label' => esc_html__( 'Add Phone', 'life-coach-agency' ),
            'section' => 'life_coach_agency_header_section_settings',
            'type' => 'text',
        )
    );

    $wp_customize->add_setting('life_coach_agency_phone_icon',array(
        'default'   => 'fas fa-phone',
        'sanitize_callback' => 'sanitize_text_field'
    ));
    $wp_customize->add_control(new Life_Coach_Agency_Changeable_Icon(
        $wp_customize,'life_coach_agency_phone_icon',array(
        'label' => __('Phone Icon','life-coach-agency'),
        'transport' => 'refresh',
        'section'   => 'life_coach_agency_header_section_settings',
        'type'      => 'icon'
    )));

    /** Sticky Header control */
    $wp_customize->add_setting( 
        'life_coach_agency_sticky_header', 
        array(
            'default' => false,
            'sanitize_callback' => 'life_coach_agency_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'life_coach_agency_sticky_header',
        array(
            'label'       => __( 'Show Sticky Header', 'life-coach-agency' ),
            'section'     => 'life_coach_agency_header_section_settings',
            'type'        => 'checkbox',
        )
    );

    // Add Setting for Menu Font Weight
    $wp_customize->add_setting( 'menu_font_weight', array(
        'default'           => '500',
        'sanitize_callback' => 'life_coach_agency_sanitize_font_weight',
    ) );

    // Add Control for Menu Font Weight
    $wp_customize->add_control( 'menu_font_weight', array(
        'label'    => __( 'Menu Font Weight', 'life-coach-agency' ),
        'section'  => 'life_coach_agency_header_section_settings',
        'type'     => 'select',
        'choices'  => array(
            '100' => __( '100 - Thin', 'life-coach-agency' ),
            '200' => __( '200 - Extra Light', 'life-coach-agency' ),
            '300' => __( '300 - Light', 'life-coach-agency' ),
            '400' => __( '400 - Normal', 'life-coach-agency' ),
            '500' => __( '500 - Medium', 'life-coach-agency' ),
            '600' => __( '600 - Semi Bold', 'life-coach-agency' ),
            '700' => __( '700 - Bold', 'life-coach-agency' ),
            '800' => __( '800 - Extra Bold', 'life-coach-agency' ),
            '900' => __( '900 - Black', 'life-coach-agency' ),
        ),
    ) );

    // Add Setting for Menu Text Transform
    $wp_customize->add_setting( 'menu_text_transform', array(
        'default'           => 'capitalize',
        'sanitize_callback' => 'life_coach_agency_sanitize_text_transform',
    ) );

    // Add Control for Menu Text Transform
    $wp_customize->add_control( 'menu_text_transform', array(
        'label'    => __( 'Menu Text Transform', 'life-coach-agency' ),
        'section'  => 'life_coach_agency_header_section_settings',
        'type'     => 'select',
        'choices'  => array(
            'none'       => __( 'None', 'life-coach-agency' ),
            'capitalize' => __( 'Capitalize', 'life-coach-agency' ),
            'uppercase'  => __( 'Uppercase', 'life-coach-agency' ),
            'lowercase'  => __( 'Lowercase', 'life-coach-agency' ),
        ),
    ) );

    $wp_customize->add_setting('life_coach_agency_menus_style',array(
        'default' => '',
        'sanitize_callback' => 'life_coach_agency_sanitize_choices'
    ));
    $wp_customize->add_control('life_coach_agency_menus_style',array(
        'type' => 'select',
        'label' => __('Menu Hover Style','life-coach-agency'),
        'section' => 'life_coach_agency_header_section_settings',
        'choices' => array(
            'None' => __('None','life-coach-agency'),
            'Zoom In' => __('Zoom In','life-coach-agency'),
        ),
    ));    

    /** Header Section Settings End */

    /** Social Section Settings */
    $wp_customize->add_section(
        'life_coach_agency_social_section_settings',
        array(
            'title' => esc_html__( 'Social Media Section Settings', 'life-coach-agency' ),
            'priority' => 30,
            'capability' => 'edit_theme_options',
            'panel' => 'life_coach_agency_home_page_settings',
        )
    );

    /** Social Section control */
    $wp_customize->add_setting( 
        'life_coach_agency_social_icon_setting', 
        array(
            'default'           => true,
            'sanitize_callback' => 'life_coach_agency_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'life_coach_agency_social_icon_setting',
        array(
            'label'       => __( 'Show / Hide Social Icon', 'life-coach-agency' ),
            'section'     => 'life_coach_agency_social_section_settings',
            'type'        => 'checkbox',
        )
    );

    /**  Social Link 1 */
    $wp_customize->add_setting(
        'life_coach_agency_social_link_1',
        array( 
            'default' => '',
            'sanitize_callback' => 'esc_url_raw',
            'transport'         => 'refresh'
        )
    );
    
    $wp_customize->add_control(
        'life_coach_agency_social_link_1',
        array(
            'label' => esc_html__( 'Add Facebook Link', 'life-coach-agency' ),
            'section' => 'life_coach_agency_social_section_settings',
            'type' => 'url',
        )
    );

    /**  Social Link 2 */
    $wp_customize->add_setting(
        'life_coach_agency_social_link_2',
        array( 
            'default' => '',
            'sanitize_callback' => 'esc_url_raw',
            'transport'         => 'refresh'
        )
    );
    
    $wp_customize->add_control(
        'life_coach_agency_social_link_2',
        array(
            'label' => esc_html__( 'Add Twitter Link', 'life-coach-agency' ),
            'section' => 'life_coach_agency_social_section_settings',
            'type' => 'url',
        )
    );

    /**  Social Link 3 */
    $wp_customize->add_setting(
        'life_coach_agency_social_link_3',
        array( 
            'default' => '',
            'sanitize_callback' => 'esc_url_raw',
            'transport'         => 'refresh'
        )
    );
    
    $wp_customize->add_control(
        'life_coach_agency_social_link_3',
        array(
            'label' => esc_html__( 'Add Instagram Link', 'life-coach-agency' ),
            'section' => 'life_coach_agency_social_section_settings',
            'type' => 'url',
        )
    );

    /**  Social Link 4 */
    $wp_customize->add_setting(
        'life_coach_agency_social_link_4',
        array( 
            'default' => '',
            'sanitize_callback' => 'esc_url_raw',
            'transport'         => 'refresh'
        )
    );
    
    $wp_customize->add_control(
        'life_coach_agency_social_link_4',
        array(
            'label' => esc_html__( 'Add Pintrest Link', 'life-coach-agency' ),
            'section' => 'life_coach_agency_social_section_settings',
            'type' => 'url',
        )
    );

    /** Social Section Settings End */

    /** Home Page Settings */
    $wp_customize->add_panel( 
        'life_coach_agency_home_page_settings',
         array(
            'priority' => 9,
            'capability' => 'edit_theme_options',
            'title' => esc_html__( 'Home Page Settings', 'life-coach-agency' ),
            'description' => esc_html__( 'Customize Home Page Settings', 'life-coach-agency' ),
        ) 
    );

    /** Slider Section Settings */
    $wp_customize->add_section(
        'life_coach_agency_slider_section_settings',
        array(
            'title' => esc_html__( 'Slider Section Settings', 'life-coach-agency' ),
            'priority' => 30,
            'capability' => 'edit_theme_options',
            'panel' => 'life_coach_agency_home_page_settings',
        )
    );

    /** Slider Section control */
    $wp_customize->add_setting( 
        'life_coach_agency_social_slider_setting', 
        array(
            'default'           => false,
            'sanitize_callback' => 'life_coach_agency_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'life_coach_agency_social_slider_setting',
        array(
            'label'       => __( 'Show / Hide Slider', 'life-coach-agency' ),
            'section'     => 'life_coach_agency_slider_section_settings',
            'type'        => 'checkbox',
        )
    );
    
    $categories = get_categories();
        $cat_posts = array();
            $i = 0;
            $cat_posts[]='Select';
        foreach($categories as $category){
            if($i==0){
            $default = $category->slug;
            $i++;
        }
        $cat_posts[$category->slug] = $category->name;
    }

    $wp_customize->add_setting(
        'life_coach_agency_blog_slide_category',
        array(
            'default'   => 'select',
            'sanitize_callback' => 'life_coach_agency_sanitize_choices',
        )
    );
    $wp_customize->add_control(
        'life_coach_agency_blog_slide_category',
        array(
            'type'    => 'select',
            'choices' => $cat_posts,
            'label' => __('Select Category to display Latest Post','life-coach-agency'),
            'section' => 'life_coach_agency_slider_section_settings',
        )
    );

    /** About Section Settings */
    
    $wp_customize->add_section( 'life_coach_agency_section_featured_about',
        array(
        'title'      => __( 'About Us Section', 'life-coach-agency' ),
        'priority'   => 110,
        'capability' => 'edit_theme_options',
        'panel'      => 'life_coach_agency_home_page_settings',
        )
    );

    /** About Section control */
    $wp_customize->add_setting( 
        'life_coach_agency_about_setting', 
        array(
            'default'           => false,
            'sanitize_callback' => 'life_coach_agency_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'life_coach_agency_about_setting',
        array(
            'label'       => __( 'Show / Hide About', 'life-coach-agency' ),
            'section'     => 'life_coach_agency_section_featured_about',
            'type'        => 'checkbox',
        )
    );

    // Section Title
    $wp_customize->add_setting('life_coach_agency_featured_mission_section_title', 
        array(
        'default'           => '',
        'type'              => 'theme_mod',
        'capability'        => 'edit_theme_options',    
        'sanitize_callback' => 'sanitize_text_field'
        )
    );

    $wp_customize->add_control('life_coach_agency_featured_mission_section_title', 
        array(
        'label'       => __('Section Title', 'life-coach-agency'),
        'section'     => 'life_coach_agency_section_featured_about',   
        'settings'    => 'life_coach_agency_featured_mission_section_title',
        'type'        => 'text'
        )
    );

    // Post
    $wp_customize->add_setting('life_coach_agency_featured_mission_post_', 
        array(
        'type'              => 'theme_mod',
        'capability'        => 'edit_theme_options',
        'sanitize_callback' => 'life_coach_agency_dropdown_pages'
        )
    );

    $wp_customize->add_control('life_coach_agency_featured_mission_post_', 
        array(
        'label'       => __('Page #', 'life-coach-agency'),
        'section'     => 'life_coach_agency_section_featured_about',   
        'settings'    => 'life_coach_agency_featured_mission_post_',
        'type'        => 'dropdown-pages',
        )
    );

    // Button Text 
    $wp_customize->add_setting('life_coach_agency_featured_mission_section_button2_text', 
        array(
        'default'           => '',
        'type'              => 'theme_mod',
        'capability'        => 'edit_theme_options',    
        'sanitize_callback' => 'sanitize_text_field'
        )
    );

    $wp_customize->add_control('life_coach_agency_featured_mission_section_button2_text', 
        array(
        'label'       => __('Button Text', 'life-coach-agency'),
        'section'     => 'life_coach_agency_section_featured_about',   
        'settings'    => 'life_coach_agency_featured_mission_section_button2_text',
        'type'        => 'text'
        )
    );

    // Button Url 
    $wp_customize->add_setting('life_coach_agency_featured_mission_section_button2_url', 
        array(
        'default'           => '',
        'type'              => 'theme_mod',
        'capability'        => 'edit_theme_options',    
        'sanitize_callback' => 'esc_url_raw'
        )
    );

    $wp_customize->add_control('life_coach_agency_featured_mission_section_button2_url', 
        array(
        'label'       => __('Button Url', 'life-coach-agency'),
        'section'     => 'life_coach_agency_section_featured_about',   
        'settings'    => 'life_coach_agency_featured_mission_section_button2_url',
        'type'        => 'url'
        )
    );

    // About Text 1
    $wp_customize->add_setting('life_coach_agency_featured_mission_section_text1', 
        array(
        'default'           => '',
        'type'              => 'theme_mod',
        'capability'        => 'edit_theme_options',    
        'sanitize_callback' => 'sanitize_text_field'
        )
    );

    $wp_customize->add_control('life_coach_agency_featured_mission_section_text1', 
        array(
        'label'       => __('About Text 1', 'life-coach-agency'),
        'section'     => 'life_coach_agency_section_featured_about',   
        'settings'    => 'life_coach_agency_featured_mission_section_text1',
        'type'        => 'text'
        )
    );

    // About Text 2
    $wp_customize->add_setting('life_coach_agency_featured_mission_section_text2', 
        array(
        'default'           => '',
        'type'              => 'theme_mod',
        'capability'        => 'edit_theme_options',    
        'sanitize_callback' => 'sanitize_text_field'
        )
    );

    $wp_customize->add_control('life_coach_agency_featured_mission_section_text2', 
        array(
        'label'       => __('About Text 2', 'life-coach-agency'),
        'section'     => 'life_coach_agency_section_featured_about',   
        'settings'    => 'life_coach_agency_featured_mission_section_text2',
        'type'        => 'text'
        )
    );
    
    /** Home Page Settings Ends */
    
    /** Footer Section */
    $wp_customize->add_section(
        'life_coach_agency_footer_section',
        array(
            'title' => __( 'Footer Settings', 'life-coach-agency' ),
            'priority' => 70,
            'panel' => 'life_coach_agency_home_page_settings',
        )
    );

    /** Footer Copyright Section control */
    $wp_customize->add_setting( 
        'life_coach_agency_footer_copyright_setting', 
        array(
            'default'           => true,
            'sanitize_callback' => 'life_coach_agency_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'life_coach_agency_footer_copyright_setting',
        array(
            'label'       => __( 'Show / Hide Footer Copyright', 'life-coach-agency' ),
            'section'     => 'life_coach_agency_footer_section',
            'type'        => 'checkbox',
        )
    );
    
    /** Copyright Text */
    $wp_customize->add_setting(
        'life_coach_agency_footer_copyright_text',
        array(
            'default' => '',
            'sanitize_callback' => 'sanitize_text_field',
        )
    );
    
    $wp_customize->add_control(
        'life_coach_agency_footer_copyright_text',
        array(
            'label' => __( 'Copyright Info', 'life-coach-agency' ),
            'section' => 'life_coach_agency_footer_section',
            'type' => 'text',
        )
    );  

    /* Footer Background Color*/
    $wp_customize->add_setting(
        'footer_background_color',
        array(
            'default' => '',
            'sanitize_callback' => 'sanitize_hex_color',
        )
    );
    $wp_customize->add_control(
        new WP_Customize_Color_Control(
            $wp_customize,
            'footer_background_color',
            array(
                'label' => __('Footer Widget Area Background Color', 'life-coach-agency'),
                'section' => 'life_coach_agency_footer_section',
                'type' => 'color',
            )
        )
    );

    $wp_customize->add_setting('footer_background_image',
        array(
        'default' => '',
        'capability' => 'edit_theme_options',
        'sanitize_callback' => 'absint',
        )
    );

    $wp_customize->add_control(
         new WP_Customize_Cropped_Image_Control($wp_customize, 'footer_background_image',
            array(
                'label' => esc_html__('Footer Background Image', 'life-coach-agency'),
                'description' => sprintf(esc_html__('Recommended Size %1$s px X %2$s px', 'life-coach-agency'), 1024, 800),
                'section' => 'life_coach_agency_footer_section',
                'width' => 1024,
                'height' => 800,
                'flex_width' => true,
                'flex_height' => true,
            )
        )
    );

    /** Footer Background Image Attachment */
    $wp_customize->add_setting('life_coach_agency_background_attatchment', array(
        'default'           => 'scroll',
        'sanitize_callback' => 'life_coach_agency_sanitize_choices',
    ));

    $wp_customize->add_control('life_coach_agency_background_attatchment', array(
        'label'    => __('Footer Background Attachment', 'life-coach-agency'),
        'section'  => 'life_coach_agency_footer_section',
        'settings' => 'life_coach_agency_background_attatchment',
        'type'     => 'select',
        'choices'  => array(
            'fixed' => __('fixed','life-coach-agency'),
            'scroll' => __('scroll','life-coach-agency'),
        ),
    ));

    /** Scroll To Top control */
    $wp_customize->add_setting( 
        'life_coach_agency_footer_scroll_to_top', 
        array(
            'default'           => true,
            'sanitize_callback' => 'life_coach_agency_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'life_coach_agency_footer_scroll_to_top',
        array(
            'label'       => __( 'Show / Hide Scroll To Top', 'life-coach-agency' ),
            'section'     => 'life_coach_agency_footer_section',
            'type'        => 'checkbox',
        )
    );

    $wp_customize->add_setting('life_coach_agency_scroll_icon',array(
        'default'   => 'fas fa-arrow-up',
        'sanitize_callback' => 'sanitize_text_field'
    ));
    $wp_customize->add_control(new Life_Coach_Agency_Changeable_Icon(
        $wp_customize,'life_coach_agency_scroll_icon',array(
        'label' => __('Scroll Top Icon','life-coach-agency'),
        'transport' => 'refresh',
        'section'   => 'life_coach_agency_footer_section',
        'type'      => 'icon'
    )));

    $wp_customize->add_setting('life_coach_agency_scroll_top_alignment',array(
        'default' => 'right-align',
        'sanitize_callback' => 'life_coach_agency_sanitize_scroll_top_alignment'
    ));
    $wp_customize->add_control('life_coach_agency_scroll_top_alignment',array(
        'type' => 'select',
        'label' => __('Scroll Top Alignment','life-coach-agency'),
        'section' => 'life_coach_agency_footer_section',
        'choices' => array(
            'right-align' => __('Right Alignment','life-coach-agency'),
            'center-align' => __('Center Alignment','life-coach-agency'),
            'left-align' => __('Left Alignment','life-coach-agency'),
        ),
    ) );

    /** Scroll to top button shape */
    $wp_customize->add_setting('life_coach_agency_scroll_to_top_radius', array(
        'default'           => 'curved-box',
        'sanitize_callback' => 'life_coach_agency_sanitize_choices',
    ));

    $wp_customize->add_control('life_coach_agency_scroll_to_top_radius', array(
        'label'    => __('Scroll Top Button Shape', 'life-coach-agency'),
        'section'  => 'life_coach_agency_footer_section',
        'settings' => 'life_coach_agency_scroll_to_top_radius',
        'type'     => 'select',
        'choices'  => array(
            'box'        => __( 'Box', 'life-coach-agency' ),
            'curved-box' => __( 'Curved Box', 'life-coach-agency' ),
            'circle'     => __( 'Circle', 'life-coach-agency' ),
        ),
    ));

    // 404 PAGE SETTINGS
    $wp_customize->add_section(
        'life_coach_agency_404_section',
        array(
            'title' => __( '404 Page Settings', 'life-coach-agency' ),
            'priority' => 70,
            'panel' => 'life_coach_agency_general_settings',
        )
    );
   
    $wp_customize->add_setting('404_page_image', array(
        'default' => '',
        'transport' => 'refresh',
        'sanitize_callback' => 'esc_url_raw', // Sanitize as URL
    ));

    $wp_customize->add_control(new WP_Customize_Image_Control($wp_customize, '404_page_image', array(
        'label' => __('404 Page Image', 'life-coach-agency'),
        'section' => 'life_coach_agency_404_section',
        'settings' => '404_page_image',
    )));

    $wp_customize->add_setting('404_pagefirst_header', array(
        'default' => __('404', 'life-coach-agency'),
        'transport' => 'refresh',
        'sanitize_callback' => 'sanitize_text_field', // Sanitize as text field
    ));

    $wp_customize->add_control('404_pagefirst_header', array(
        'type' => 'text',
        'label' => __('Heading', 'life-coach-agency'),
        'section' => 'life_coach_agency_404_section',
    ));

    // Setting for 404 page header
    $wp_customize->add_setting('404_page_header', array(
        'default' => __('Sorry, that page can\'t be found!', 'life-coach-agency'),
        'transport' => 'refresh',
        'sanitize_callback' => 'sanitize_text_field', // Sanitize as text field
    ));

    $wp_customize->add_control('404_page_header', array(
        'type' => 'text',
        'label' => __('Heading', 'life-coach-agency'),
        'section' => 'life_coach_agency_404_section',
    ));
}
add_action( 'customize_register', 'life_coach_agency_customize_register' );
endif;

/**
 * Binds JS handlers to make Theme Customizer preview reload changes asynchronously.
 */
function life_coach_agency_customize_preview_js() {
    // Use minified libraries if SCRIPT_DEBUG is false
    $life_coach_agency_build  = ( defined( 'SCRIPT_DEBUG' ) && SCRIPT_DEBUG ) ? '/build' : '';
    $life_coach_agency_suffix = ( defined( 'SCRIPT_DEBUG' ) && SCRIPT_DEBUG ) ? '' : '.min';
	wp_enqueue_script( 'life_coach_agency_customizer', get_template_directory_uri() . '/js' . $life_coach_agency_build . '/customizer' . $life_coach_agency_suffix . '.js', array( 'customize-preview' ), '20130508', true );
}
add_action( 'customize_preview_init', 'life_coach_agency_customize_preview_js' );